clear all;

% detection from 600dpi scans:
load scannerrgb2xyz.mat;
wmcx = imread('wmcxkod.bmp');wmcx = wmcx(1:2048,1:2304);wmcz = imread('wmczkod.bmp');wmcz = wmcz(1:2048,1:2304);
i = imread('kod1600_25.tif');ir = img2row(i);ir = polyconvert3(ir',ABC)';y = xyz2ycc(ir); y = row2img(y,2048,2304); N = 32;yy = y(:,:,1);cx = y(:,:,2);cz = y(:,:,3); YY = subfft(yy,N); CZ = subfft(cz,N); CX = subfft(cx,N);
[cxd, czd] = PCAdetector(CX,CZ,32,2.5,2,1,2);cdrPCA600 = [cdrn(cxd,wmcx,32,2,512,768); cdrn(czd,wmcz,32,2,512,768)]';
[cxd, czd] = detectPCAold(CX,CZ,32,2.5,2,'');cdrPCAold600 = [cdrn(cxd,wmcx,32,2,512,768); cdrn(czd,wmcz,32,2,512,768)]';
[cxd, czd] = LMSdetector(CX,CZ,32,2.5,2,1,'');cdrLMS600 = [cdrn(cxd,wmcx,32,2,512,768); cdrn(czd,wmcz,32,2,512,768)]';
[cxd, czd] = DICTdetector(CX,CZ,32,2.5,2,1,'',2,128);cdrDICT600 = [cdrn(cxd,wmcx,32,2,512,768); cdrn(czd,wmcz,32,2,512,768)]';
[cxd, czd] = MOMdetector(CX,CZ,32,2.5,2,1);cdrMOM600 = [cdrn(cxd,wmcx,32,2,512,768); cdrn(czd,wmcz,32,2,512,768)]';
i = imread('kod2600_25.tif');ir = img2row(i);ir = polyconvert3(ir',ABC)';y = xyz2ycc(ir); y = row2img(y,2048,2304); N = 32;yy = y(:,:,1);cx = y(:,:,2);cz = y(:,:,3); YY = subfft(yy,N); CZ = subfft(cz,N); CX = subfft(cx,N);
[cxd, czd] = PCAdetector(CX,CZ,32,2.5,2,1,2);cdrPCA600 = [cdrPCA600',[cdrn(cxd,wmcx,32,2,512,768); cdrn(czd,wmcz,32,2,512,768)]]';
[cxd, czd] = detectPCAold(CX,CZ,32,2.5,2,'');cdrPCAold600 = [cdrPCAold600',[cdrn(cxd,wmcx,32,2,512,768); cdrn(czd,wmcz,32,2,512,768)]]';
[cxd, czd] = LMSdetector(CX,CZ,32,2.5,2,1,'');cdrLMS600 = [cdrLMS600',[cdrn(cxd,wmcx,32,2,512,768); cdrn(czd,wmcz,32,2,512,768)]]';
[cxd, czd] = DICTdetector(CX,CZ,32,2.5,2,1,'',2,128);cdrDICT600 = [cdrDICT600',[cdrn(cxd,wmcx,32,2,512,768); cdrn(czd,wmcz,32,2,512,768)]]';
[cxd, czd] = MOMdetector(CX,CZ,32,2.5,2,1);cdrMOM600 = [cdrMOM600',[cdrn(cxd,wmcx,32,2,512,768); cdrn(czd,wmcz,32,2,512,768)]]';
wmcx = imread('wmcxcsiq.bmp');wmcx = wmcx(1:1920,1:3200);wmcz = imread('wmczcsiq.bmp');wmcz = wmcz(1:1920,1:3200);
i = imread('csiq1600_25.tif');ir = img2row(i);ir = polyconvert3(ir',ABC)';y = xyz2ycc(ir); y = row2img(y,1920,3200); N = 32;yy = y(:,:,1);cx = y(:,:,2);cz = y(:,:,3); YY = subfft(yy,N); CZ = subfft(cz,N); CX = subfft(cx,N);
[cxd, czd] = PCAdetector(CX,CZ,32,2.5,2,1,2);cdrPCA600 = [cdrPCA600',[cdrn(cxd,wmcx,32,2,640,640); cdrn(czd,wmcz,32,2,640,640)]]';
[cxd, czd] = detectPCAold(CX,CZ,32,2.5,2,'');cdrPCAold600 = [cdrPCAold600',[cdrn(cxd,wmcx,32,2,640,640); cdrn(czd,wmcz,32,2,640,640)]]';
[cxd, czd] = LMSdetector(CX,CZ,32,2.5,2,1,'');cdrLMS600 = [cdrLMS600',[cdrn(cxd,wmcx,32,2,640,640); cdrn(czd,wmcz,32,2,640,640)]]';
[cxd, czd] = DICTdetector(CX,CZ,32,2.5,2,1,'',2,128);cdrDICT600 = [cdrDICT600',[cdrn(cxd,wmcx,32,2,640,640); cdrn(czd,wmcz,32,2,640,640)]]';
[cxd, czd] = MOMdetector(CX,CZ,32,2.5,2,1);cdrMOM600 = [cdrMOM600',[cdrn(cxd,wmcx,32,2,640,640); cdrn(czd,wmcz,32,2,640,640)]]';
i = imread('csiq2600_25.tif');ir = img2row(i);ir = polyconvert3(ir',ABC)';y = xyz2ycc(ir); y = row2img(y,1920,3200); N = 32;yy = y(:,:,1);cx = y(:,:,2);cz = y(:,:,3); YY = subfft(yy,N); CZ = subfft(cz,N); CX = subfft(cx,N);
[cxd, czd] = PCAdetector(CX,CZ,32,2.5,2,1,2);cdrPCA600 = [cdrPCA600',[cdrn(cxd,wmcx,32,2,640,640); cdrn(czd,wmcz,32,2,640,640)]]';
[cxd, czd] = detectPCAold(CX,CZ,32,2.5,2,'');cdrPCAold600 = [cdrPCAold600',[cdrn(cxd,wmcx,32,2,640,640); cdrn(czd,wmcz,32,2,640,640)]]';
[cxd, czd] = LMSdetector(CX,CZ,32,2.5,2,1,'');cdrLMS600 = [cdrLMS600',[cdrn(cxd,wmcx,32,2,640,640); cdrn(czd,wmcz,32,2,640,640)]]';
[cxd, czd] = DICTdetector(CX,CZ,32,2.5,2,1,'',2,128);cdrDICT600 = [cdrDICT600',[cdrn(cxd,wmcx,32,2,640,640); cdrn(czd,wmcz,32,2,640,640)]]';
[cxd, czd] = MOMdetector(CX,CZ,32,2.5,2,1);cdrMOM600 = [cdrMOM600',[cdrn(cxd,wmcx,32,2,640,640); cdrn(czd,wmcz,32,2,640,640)]]';

% detection from 300dpi scans:
load scannerrgb2xyz.mat;
wmcx = imread('wmcxkod.bmp');wmcx = wmcx(1:2048,1:2304);wmcz = imread('wmczkod.bmp');wmcz = wmcz(1:2048,1:2304);
i = imread('kod1300_25.tif');ir = img2row(i);ir = polyconvert3(ir',ABC)';y = xyz2ycc(ir); y = row2img(y,2048,2304); N = 32;yy = y(:,:,1);cx = y(:,:,2);cz = y(:,:,3); YY = subfft(yy,N); CZ = subfft(cz,N); CX = subfft(cx,N);
[cxd, czd] = PCAdetector(CX,CZ,32,2.5,2,1,2);cdrPCA300 = [cdrn(cxd,wmcx,32,2,512,768); cdrn(czd,wmcz,32,2,512,768)]';
[cxd, czd] = detectPCAold(CX,CZ,32,2.5,2,'');cdrPCAold300 = [cdrn(cxd,wmcx,32,2,512,768); cdrn(czd,wmcz,32,2,512,768)]';
[cxd, czd] = LMSdetector(CX,CZ,32,2.5,2,1,'');cdrLMS300 = [cdrn(cxd,wmcx,32,2,512,768); cdrn(czd,wmcz,32,2,512,768)]';
[cxd, czd] = DICTdetector(CX,CZ,32,2.5,2,1,'',2,128);cdrDICT300 = [cdrn(cxd,wmcx,32,2,512,768); cdrn(czd,wmcz,32,2,512,768)]';
[cxd, czd] = MOMdetector(CX,CZ,32,2.5,2,1);cdrMOM300 = [cdrn(cxd,wmcx,32,2,512,768); cdrn(czd,wmcz,32,2,512,768)]';
i = imread('kod2300_25.tif');ir = img2row(i);ir = polyconvert3(ir',ABC)';y = xyz2ycc(ir); y = row2img(y,2048,2304); N = 32;yy = y(:,:,1);cx = y(:,:,2);cz = y(:,:,3); YY = subfft(yy,N); CZ = subfft(cz,N); CX = subfft(cx,N);
[cxd, czd] = PCAdetector(CX,CZ,32,2.5,2,1,2);cdrPCA300 = [cdrPCA300',[cdrn(cxd,wmcx,32,2,512,768); cdrn(czd,wmcz,32,2,512,768)]]';
[cxd, czd] = detectPCAold(CX,CZ,32,2.5,2,'');cdrPCAold300 = [cdrPCAold300',[cdrn(cxd,wmcx,32,2,512,768); cdrn(czd,wmcz,32,2,512,768)]]';
[cxd, czd] = LMSdetector(CX,CZ,32,2.5,2,1,'');cdrLMS300 = [cdrLMS300',[cdrn(cxd,wmcx,32,2,512,768); cdrn(czd,wmcz,32,2,512,768)]]';
[cxd, czd] = DICTdetector(CX,CZ,32,2.5,2,1,'',2,128);cdrDICT300 = [cdrDICT300',[cdrn(cxd,wmcx,32,2,512,768); cdrn(czd,wmcz,32,2,512,768)]]';
[cxd, czd] = MOMdetector(CX,CZ,32,2.5,2,1);cdrMOM300 = [cdrMOM300',[cdrn(cxd,wmcx,32,2,512,768); cdrn(czd,wmcz,32,2,512,768)]]';
wmcx = imread('wmcxcsiq.bmp');wmcx = wmcx(1:1920,1:3200);wmcz = imread('wmczcsiq.bmp');wmcz = wmcz(1:1920,1:3200);
i = imread('csiq1300_25.tif');ir = img2row(i);ir = polyconvert3(ir',ABC)';y = xyz2ycc(ir); y = row2img(y,1920,3200); N = 32;yy = y(:,:,1);cx = y(:,:,2);cz = y(:,:,3); YY = subfft(yy,N); CZ = subfft(cz,N); CX = subfft(cx,N);
[cxd, czd] = PCAdetector(CX,CZ,32,2.5,2,1,2);cdrPCA300 = [cdrPCA300',[cdrn(cxd,wmcx,32,2,640,640); cdrn(czd,wmcz,32,2,640,640)]]';
[cxd, czd] = detectPCAold(CX,CZ,32,2.5,2,'');cdrPCAold300 = [cdrPCAold300',[cdrn(cxd,wmcx,32,2,640,640); cdrn(czd,wmcz,32,2,640,640)]]';
[cxd, czd] = LMSdetector(CX,CZ,32,2.5,2,1,'');cdrLMS300 = [cdrLMS300',[cdrn(cxd,wmcx,32,2,640,640); cdrn(czd,wmcz,32,2,640,640)]]';
[cxd, czd] = DICTdetector(CX,CZ,32,2.5,2,1,'',2,128);cdrDICT300 = [cdrDICT300',[cdrn(cxd,wmcx,32,2,640,640); cdrn(czd,wmcz,32,2,640,640)]]';
[cxd, czd] = MOMdetector(CX,CZ,32,2.5,2,1);cdrMOM300 = [cdrMOM300',[cdrn(cxd,wmcx,32,2,640,640); cdrn(czd,wmcz,32,2,640,640)]]';
i = imread('csiq2300_25.tif');ir = img2row(i);ir = polyconvert3(ir',ABC)';y = xyz2ycc(ir); y = row2img(y,1920,3200); N = 32;yy = y(:,:,1);cx = y(:,:,2);cz = y(:,:,3); YY = subfft(yy,N); CZ = subfft(cz,N); CX = subfft(cx,N);
[cxd, czd] = PCAdetector(CX,CZ,32,2.5,2,1,2);cdrPCA300 = [cdrPCA300',[cdrn(cxd,wmcx,32,2,640,640); cdrn(czd,wmcz,32,2,640,640)]]';
[cxd, czd] = detectPCAold(CX,CZ,32,2.5,2,'');cdrPCAold300 = [cdrPCAold300',[cdrn(cxd,wmcx,32,2,640,640); cdrn(czd,wmcz,32,2,640,640)]]';
[cxd, czd] = LMSdetector(CX,CZ,32,2.5,2,1,'');cdrLMS300 = [cdrLMS300',[cdrn(cxd,wmcx,32,2,640,640); cdrn(czd,wmcz,32,2,640,640)]]';
[cxd, czd] = DICTdetector(CX,CZ,32,2.5,2,1,'',2,128);cdrDICT300 = [cdrDICT300',[cdrn(cxd,wmcx,32,2,640,640); cdrn(czd,wmcz,32,2,640,640)]]';
[cxd, czd] = MOMdetector(CX,CZ,32,2.5,2,1);cdrMOM300 = [cdrMOM300',[cdrn(cxd,wmcx,32,2,640,640); cdrn(czd,wmcz,32,2,640,640)]]';


% detection from Canon Powershoot A700 captured images:
wmcx = imread('wmcxkod.bmp');wmcx = wmcx(1:2048,1:2304);wmcz = imread('wmczkod.bmp');wmcz = wmcz(1:2048,1:2304);
i = imread('kod1can_25.tif');xyz=rgb2xyz(i,'ColorSpace','srgb','WhitePoint','d50');ir = img2row(xyz);y = xyz2ycc(ir); y = row2img(y,2048,2304); N = 32;yy = y(:,:,1);cx = y(:,:,2);cz = y(:,:,3); YY = subfft(yy,N); CZ = subfft(cz,N); CX = subfft(cx,N);
[cxd, czd] = PCAdetector(CX,CZ,32,2.5,2,1,2);cdrPCAcan = [cdrn(cxd,wmcx,32,2,512,768); cdrn(czd,wmcz,32,2,512,768)]';
[cxd, czd] = detectPCAold(CX,CZ,32,2.5,2,'');cdrPCAoldcan = [cdrn(cxd,wmcx,32,2,512,768); cdrn(czd,wmcz,32,2,512,768)]';
[cxd, czd] = LMSdetector(CX,CZ,32,2.5,2,1,'');cdrLMScan = [cdrn(cxd,wmcx,32,2,512,768); cdrn(czd,wmcz,32,2,512,768)]';
[cxd, czd] = DICTdetector(CX,CZ,32,2.5,2,1,'',2,128);cdrDICTcan = [cdrn(cxd,wmcx,32,2,512,768); cdrn(czd,wmcz,32,2,512,768)]';
[cxd, czd] = MOMdetector(CX,CZ,32,2.5,2,1);cdrMOMcan = [cdrn(cxd,wmcx,32,2,512,768); cdrn(czd,wmcz,32,2,512,768)]';
i = imread('kod2can_25.tif');xyz=rgb2xyz(i,'ColorSpace','srgb','WhitePoint','d50');ir = img2row(xyz);y = xyz2ycc(ir); y = row2img(y,2048,2304); N = 32;yy = y(:,:,1);cx = y(:,:,2);cz = y(:,:,3); YY = subfft(yy,N); CZ = subfft(cz,N); CX = subfft(cx,N);
[cxd, czd] = PCAdetector(CX,CZ,32,2.5,2,1,2);cdrPCAcan = [cdrPCAcan',[cdrn(cxd,wmcx,32,2,512,768); cdrn(czd,wmcz,32,2,512,768)]]';
[cxd, czd] = detectPCAold(CX,CZ,32,2.5,2,'');cdrPCAoldcan = [cdrPCAoldcan',[cdrn(cxd,wmcx,32,2,512,768); cdrn(czd,wmcz,32,2,512,768)]]';
[cxd, czd] = LMSdetector(CX,CZ,32,2.5,2,1,'');cdrLMScan = [cdrLMScan',[cdrn(cxd,wmcx,32,2,512,768); cdrn(czd,wmcz,32,2,512,768)]]';
[cxd, czd] = DICTdetector(CX,CZ,32,2.5,2,1,'',2,128);cdrDICTcan = [cdrDICTcan',[cdrn(cxd,wmcx,32,2,512,768); cdrn(czd,wmcz,32,2,512,768)]]';
[cxd, czd] = MOMdetector(CX,CZ,32,2.5,2,1);cdrMOMcan = [cdrMOMcan',[cdrn(cxd,wmcx,32,2,512,768); cdrn(czd,wmcz,32,2,512,768)]]';
wmcx = imread('wmcxcsiq.bmp');wmcx = wmcx(1:1920,1:3200);wmcz = imread('wmczcsiq.bmp');wmcz = wmcz(1:1920,1:3200);
i = imread('csiq1can_25.tif');xyz=rgb2xyz(i,'ColorSpace','srgb','WhitePoint','d50');ir = img2row(xyz);y = xyz2ycc(ir); y = row2img(y,1920,3200); N = 32;yy = y(:,:,1);cx = y(:,:,2);cz = y(:,:,3); YY = subfft(yy,N); CZ = subfft(cz,N); CX = subfft(cx,N);
[cxd, czd] = PCAdetector(CX,CZ,32,2.5,2,1,2);cdrPCAcan = [cdrPCAcan',[cdrn(cxd,wmcx,32,2,640,640); cdrn(czd,wmcz,32,2,640,640)]]';
[cxd, czd] = detectPCAold(CX,CZ,32,2.5,2,'');cdrPCAoldcan = [cdrPCAoldcan',[cdrn(cxd,wmcx,32,2,640,640); cdrn(czd,wmcz,32,2,640,640)]]';
[cxd, czd] = LMSdetector(CX,CZ,32,2.5,2,1,'');cdrLMScan = [cdrLMScan',[cdrn(cxd,wmcx,32,2,640,640); cdrn(czd,wmcz,32,2,640,640)]]';
[cxd, czd] = DICTdetector(CX,CZ,32,2.5,2,1,'',2,128);cdrDICTcan = [cdrDICTcan',[cdrn(cxd,wmcx,32,2,640,640); cdrn(czd,wmcz,32,2,640,640)]]';
[cxd, czd] = MOMdetector(CX,CZ,32,2.5,2,1);cdrMOMcan = [cdrMOMcan',[cdrn(cxd,wmcx,32,2,640,640); cdrn(czd,wmcz,32,2,640,640)]]';
i = imread('csiq2can_25.tif');xyz=rgb2xyz(i,'ColorSpace','srgb','WhitePoint','d50');ir = img2row(xyz);y = xyz2ycc(ir); y = row2img(y,1920,3200); N = 32;yy = y(:,:,1);cx = y(:,:,2);cz = y(:,:,3); YY = subfft(yy,N); CZ = subfft(cz,N); CX = subfft(cx,N);
[cxd, czd] = PCAdetector(CX,CZ,32,2.5,2,1,2);cdrPCAcan = [cdrPCAcan',[cdrn(cxd,wmcx,32,2,640,640); cdrn(czd,wmcz,32,2,640,640)]]';
[cxd, czd] = detectPCAold(CX,CZ,32,2.5,2,'');cdrPCAoldcan = [cdrPCAoldcan',[cdrn(cxd,wmcx,32,2,640,640); cdrn(czd,wmcz,32,2,640,640)]]';
[cxd, czd] = LMSdetector(CX,CZ,32,2.5,2,1,'');cdrLMScan = [cdrLMScan',[cdrn(cxd,wmcx,32,2,640,640); cdrn(czd,wmcz,32,2,640,640)]]';
[cxd, czd] = DICTdetector(CX,CZ,32,2.5,2,1,'',2,128);cdrDICTcan = [cdrDICTcan',[cdrn(cxd,wmcx,32,2,640,640); cdrn(czd,wmcz,32,2,640,640)]]';
[cxd, czd] = MOMdetector(CX,CZ,32,2.5,2,1);cdrMOMcan = [cdrMOMcan',[cdrn(cxd,wmcx,32,2,640,640); cdrn(czd,wmcz,32,2,640,640)]]';


% detection from Huawei Honor 7 captured images:
wmcx = imread('wmcxkod.bmp');wmcx = wmcx(1:2048,1:2304);wmcz = imread('wmczkod.bmp');wmcz = wmcz(1:2048,1:2304);
i = imread('kod1hua_25.tif');xyz=rgb2xyz(i,'ColorSpace','srgb','WhitePoint','d50');ir = img2row(xyz);y = xyz2ycc(ir); y = row2img(y,2048,2304); N = 32;yy = y(:,:,1);cx = y(:,:,2);cz = y(:,:,3); YY = subfft(yy,N); CZ = subfft(cz,N); CX = subfft(cx,N);
[cxd, czd] = PCAdetector(CX,CZ,32,2.5,2,1,2);cdrPCAhua = [cdrn(cxd,wmcx,32,2,512,768); cdrn(czd,wmcz,32,2,512,768)]';
[cxd, czd] = detectPCAold(CX,CZ,32,2.5,2,'');cdrPCAoldhua = [cdrn(cxd,wmcx,32,2,512,768); cdrn(czd,wmcz,32,2,512,768)]';
[cxd, czd] = LMSdetector(CX,CZ,32,2.5,2,1,'');cdrLMShua = [cdrn(cxd,wmcx,32,2,512,768); cdrn(czd,wmcz,32,2,512,768)]';
[cxd, czd] = DICTdetector(CX,CZ,32,2.5,2,1,'',2,128);cdrDICThua = [cdrn(cxd,wmcx,32,2,512,768); cdrn(czd,wmcz,32,2,512,768)]';
[cxd, czd] = MOMdetector(CX,CZ,32,2.5,2,1);cdrMOMhua = [cdrn(cxd,wmcx,32,2,512,768); cdrn(czd,wmcz,32,2,512,768)]';
i = imread('kod2hua_25.tif');xyz=rgb2xyz(i,'ColorSpace','srgb','WhitePoint','d50');ir = img2row(xyz);y = xyz2ycc(ir); y = row2img(y,2048,2304); N = 32;yy = y(:,:,1);cx = y(:,:,2);cz = y(:,:,3); YY = subfft(yy,N); CZ = subfft(cz,N); CX = subfft(cx,N);
[cxd, czd] = PCAdetector(CX,CZ,32,2.5,2,1,2);cdrPCAhua = [cdrPCAhua',[cdrn(cxd,wmcx,32,2,512,768); cdrn(czd,wmcz,32,2,512,768)]]';
[cxd, czd] = detectPCAold(CX,CZ,32,2.5,2,'');cdrPCAoldhua = [cdrPCAoldhua',[cdrn(cxd,wmcx,32,2,512,768); cdrn(czd,wmcz,32,2,512,768)]]';
[cxd, czd] = LMSdetector(CX,CZ,32,2.5,2,1,'');cdrLMShua = [cdrLMShua',[cdrn(cxd,wmcx,32,2,512,768); cdrn(czd,wmcz,32,2,512,768)]]';
[cxd, czd] = DICTdetector(CX,CZ,32,2.5,2,1,'',2,128);cdrDICThua = [cdrDICThua',[cdrn(cxd,wmcx,32,2,512,768); cdrn(czd,wmcz,32,2,512,768)]]';
[cxd, czd] = MOMdetector(CX,CZ,32,2.5,2,1);cdrMOMhua = [cdrMOMhua',[cdrn(cxd,wmcx,32,2,512,768); cdrn(czd,wmcz,32,2,512,768)]]';
wmcx = imread('wmcxcsiq.bmp');wmcx = wmcx(1:1920,1:3200);wmcz = imread('wmczcsiq.bmp');wmcz = wmcz(1:1920,1:3200);
i = imread('csiq1hua_25.tif');xyz=rgb2xyz(i,'ColorSpace','srgb','WhitePoint','d50');ir = img2row(xyz);y = xyz2ycc(ir); y = row2img(y,1920,3200); N = 32;yy = y(:,:,1);cx = y(:,:,2);cz = y(:,:,3); YY = subfft(yy,N); CZ = subfft(cz,N); CX = subfft(cx,N);
[cxd, czd] = PCAdetector(CX,CZ,32,2.5,2,1,2);cdrPCAhua = [cdrPCAhua',[cdrn(cxd,wmcx,32,2,640,640); cdrn(czd,wmcz,32,2,640,640)]]';
[cxd, czd] = detectPCAold(CX,CZ,32,2.5,2,'');cdrPCAoldhua = [cdrPCAoldhua',[cdrn(cxd,wmcx,32,2,640,640); cdrn(czd,wmcz,32,2,640,640)]]';
[cxd, czd] = LMSdetector(CX,CZ,32,2.5,2,1,'');cdrLMShua = [cdrLMShua',[cdrn(cxd,wmcx,32,2,640,640); cdrn(czd,wmcz,32,2,640,640)]]';
[cxd, czd] = DICTdetector(CX,CZ,32,2.5,2,1,'',2,128);cdrDICThua = [cdrDICThua',[cdrn(cxd,wmcx,32,2,640,640); cdrn(czd,wmcz,32,2,640,640)]]';
[cxd, czd] = MOMdetector(CX,CZ,32,2.5,2,1);cdrMOMhua = [cdrMOMhua',[cdrn(cxd,wmcx,32,2,640,640); cdrn(czd,wmcz,32,2,640,640)]]';
i = imread('csiq2hua_25.tif');xyz=rgb2xyz(i,'ColorSpace','srgb','WhitePoint','d50');ir = img2row(xyz);y = xyz2ycc(ir); y = row2img(y,1920,3200); N = 32;yy = y(:,:,1);cx = y(:,:,2);cz = y(:,:,3); YY = subfft(yy,N); CZ = subfft(cz,N); CX = subfft(cx,N);
[cxd, czd] = PCAdetector(CX,CZ,32,2.5,2,1,2);cdrPCAhua = [cdrPCAhua',[cdrn(cxd,wmcx,32,2,640,640); cdrn(czd,wmcz,32,2,640,640)]]';
[cxd, czd] = detectPCAold(CX,CZ,32,2.5,2,'');cdrPCAoldhua = [cdrPCAoldhua',[cdrn(cxd,wmcx,32,2,640,640); cdrn(czd,wmcz,32,2,640,640)]]';
[cxd, czd] = LMSdetector(CX,CZ,32,2.5,2,1,'');cdrLMShua = [cdrLMShua',[cdrn(cxd,wmcx,32,2,640,640); cdrn(czd,wmcz,32,2,640,640)]]';
[cxd, czd] = DICTdetector(CX,CZ,32,2.5,2,1,'',2,128);cdrDICThua = [cdrDICThua',[cdrn(cxd,wmcx,32,2,640,640); cdrn(czd,wmcz,32,2,640,640)]]';
[cxd, czd] = MOMdetector(CX,CZ,32,2.5,2,1);cdrMOMhua = [cdrMOMhua',[cdrn(cxd,wmcx,32,2,640,640); cdrn(czd,wmcz,32,2,640,640)]]';

save results.mat cdr*

