function res = subfft(x,N)
x = double(x);
rows = size(x,1);
cols = size(x,2);
rn = floor(rows/N);
cn = floor(cols/N);
res = zeros(rn*32,cn*32);

for r = 1:rows/N,
    for c = 1:cols/N,
        subim = x((r-1)*N+1:r*N,(c-1)*N+1:c*N);
        SUBIM = log(abs(fftshift(fft2(subim,32,32)))+1);
        res((r-1)*32+1:r*32,(c-1)*32+1:c*32) = SUBIM;
    end
end