function y = img2row(x)
% converts 3 channel uint8 MxN image to double 3xMN row
rows = size(x,1);
cols = size(x,2);
rez = uint8(zeros(3,rows*cols));

c1 = x(:,:,1);
c2 = x(:,:,2);
c3 = x(:,:,3);
rez(1,:)=c1(:);
rez(2,:)=c2(:);
rez(3,:)=c3(:);
y = double(rez);

